/**** MODULE $MSCDEF *** */
#define MSC$C_MSG 0                  /* CONTAINS ACTUAL MESSAGE TEXT */
#define MSC$C_IND 1                  /* CONTAINS FILE SPEC OF MESSAGE FILE */
#define MSC$C_MAXTYPE 2              /* MAXIMUM ALLOWABLE TYPE CODE */
#define MSC$M_MAPPED 1
#define MSC$C_SANITY 1234
#define MSC$K_LENGTH 40              /* LENGTH OF FIXED PORTION (MSG) */
#define MSC$C_LENGTH 40              /* LENGTH OF FIXED PORTION (MSG) */
#define MSC$S_MSCDEF 40
#define MSC$S_MSCDEF1 10

#pragma __member_alignment __save
#pragma __nomember_alignment
struct mscdef
{
  char msc$b_type;		/* type of message section */
  union
  {
    char msc$b_flags;		/* flags */
    struct
    {
      unsigned char msc$v_mapped:1;	/* true if file has been mapped (ind only) */
    } msc$r_flags_bits;
  }msc$r_flags_overlay;
#define msc$b_flags msc$r_flags_overlay.msc$b_flags
#define msc$v_mapped msc$r_flags_overlay.msc$r_flags_bits.msc$v_mapped
  short int msc$w_sanity;	/* sanity check (must msc$c_sanity) */
  long int msc$l_size;		/* length of entire message section (msg) */
  union
  {
    struct
    {
      long int msc$l_index_off;	/* offset to primary index portion */
      long int msc$l_fac_off;	/* offset to facility table */
      long int msc$l_text_off;	/* offset to text portion */
      long int msc$l_subst_off;	/* offset to text substitution table */
    } msc$r_ind;
    struct
    {
      char msc$b_indnamlen;	/* length of counted string */
      char msc$t_indname[];	/* file spec of message file */
    } msc$r_msg;
  } msc$r_type_overlay;
#define msc$l_index_off msc$r_type_overlay.msc$r_ind.msc$l_index_off
#define msc$l_fac_off msc$r_type_overlay.msc$r_ind.msc$l_fac_off
#define msc$l_text_off msc$r_type_overlay.msc$r_ind.msc$l_text_off
#define msc$l_subst_off msc$r_type_overlay.msc$r_ind.msc$l_subst_off
#define msc$b_indnamlen msc$r_type_overlay.msc$r_msg.msc$b_indnamlen
#define msc$t_indname msc$r_type_overlay.msc$r_msg.msc$t_indname
};
#pragma __member_alignment __restore

/* MODULE $MIDXDEF ****/
/*                                                               */
/* Define message section index                                  */
/*                                                               */
/*         All message indicies are longword aligned and the     */
/*         size is always rounded to the next longword boundary. */
/*         This is done for additional verification checks.      */
/*                                                               */
#define MIDX$C_BKTSIZ 512            /*  BUCKET SIZE IN BYTES  */
#define MIDX$C_SANITY 123
#define MIDX$K_LENGTH 8              /*  LENGTH OF FIXED BUCKET OVERHEAD  */
#define MIDX$C_LENGTH 8              /*  LENGTH OF FIXED BUCKET OVERHEAD  */
#define MIDX$K_ENTRIES 8             /*  START OF INDEX ENTRIES  */
#define MIDX$C_ENTRIES 8             /*  START OF INDEX ENTRIES  */
/*  EACH IS 8 BYTES, */
#define MIDX$S_MIDXDEF 8
struct midxdef
{
  short int midx$w_size;	/*  LENGTH OF INDEX IN BYTES  */
  char      midx$b_sanity;	/*  SANITY CHECK (MUST MIDX$C_SANITY)  */
};

/*  0-3: MESSAGE CODE */
/*  4-7: OFFSET TO MESSAGE RECORD */
/*       (IF LOW BIT SET, THEN OFFSET */
/*       POINTS TO SUBINDEX RATHER THAN */
/*       A MESSAGE RECORD) */
struct midx$r_entry		/* yup, I made it up too.. */
{
  long int midx$l_code;	/* I made up this name ... */
  long int midx$l_offset;	/* I made this one up too ... */
}; 

/**** MODULE $MRECDEF *** */
/*  */
/*         Message definition record in message section */
/*  */
/*         All message definition records are word aligned and */
/*         the size is rounded to the next word boundary.  This */
/*         is done for additional verification checks. */
/*  */
#define MREC$C_ENGLISH 0             /*  ENGLISH LANGUAGE (DEFAULT)  */
#define MREC$C_GERMAN 1              /*  GERMAN LANGUAGE  */
#define MREC$C_FRENCH 2              /*  FRENCH LANGUAGE  */
#define MREC$K_FIXEDLEN 9            /*  LENGTH OF FIXED PORTION OF RECORD  */
#define MREC$C_FIXEDLEN 9            /*  LENGTH OF FIXED PORTION OF RECORD  */
#define MREC$S_MRECDEF 11

struct mrecdef
{
  short int mrec$w_size;	/*  length of message definition record  */
  char mrec$b_type;		/*  type of message record  */
  char mrec$b_flags;		/*  flags  */
  char mrec$b_level;		/*  message detail level (0-255)  */
  char mrec$b_faocnt;		/*  number of fao arguments in message  */
  char mrec$b_userval;		/*  user specified value  */
  char fill;
  char mrec$b_lang;		/*  language number  */
  char mrec$b_identlen;		/*  message ident string length  */
  char mrec$t_ident[];		/*  message ident string  */
				/*  message text follows (ascic) */
};
 
/**** MODULE $MFACDEF *** */
/*  */
/*         Define facility name table within section */
/*  */
#define MFAC$S_MFACDEF 4
struct mfacdef
{
  short int mfac$w_number;	/*  facility number  */
  char mfac$b_namelen;		/*  length of facility name  */
  char mfac$t_name[];		/*  facility name (variable length)  */
};
